﻿#if NET6_0_OR_GREATER
using C1.Win.FlexGrid;
using C1.Win.Themes;
#else
using C1.Win.C1FlexGrid;
using C1.Win.C1Themes;
#endif
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static C1.Util.Win.Win32;

namespace FlexRow
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();

#if NET6_0_OR_GREATER
      this.Text += " (NET 6.0)";
#else
      this.Text += " (NET 48)";
#endif

      this.c1FlexGrid1.BeginUpdate();
      for (int row = this.c1FlexGrid1.Rows.Fixed; row < this.c1FlexGrid1.Rows.Count; row++)
      {
        for (int col = this.c1FlexGrid1.Cols.Fixed; col < this.c1FlexGrid1.Cols.Count; col++)
        {
          this.c1FlexGrid1[row, col] = "row " + row + ", col " + col;
        }
      }

      this.c1FlexGrid1.EndUpdate();

      //Now select the last row, then row 10 again - this causes the problem
      this.c1FlexGrid1.Row = this.c1FlexGrid1.Rows.Count - 1;
      this.c1FlexGrid1.Row = 10;

    }

    protected override void OnLoad(EventArgs e)
    {
      base.OnLoad(e);

      //Apply theme - issue will only happen with theme.
      //C1Theme theme = C1ThemeController.GetThemeByName("Office2010Silver", true);
      C1Theme theme = C1ThemeController.GetThemeByName("MacSilver", true);
      C1ThemeController.ApplyThemeToControlTree(this, theme);

      //Workaround 1: This would fix the issue:
      //this.c1FlexGrid1.TopRow = this.c1FlexGrid1.TopRow;

      //Workaround 2: This will also fix it:
      //this.c1FlexGrid1.BeginUpdate();
      //this.c1FlexGrid1.EndUpdate();
    }

  }
}
